com.amazonaws.services.simpleworkflow.model

## Class WorkflowTypeConfiguration

- java.lang.Object
- - com.amazonaws.services.simpleworkflow.model.WorkflowTypeConfiguration

All Implemented Interfaces:
  Serializable, Cloneable

    public class WorkflowTypeConfiguration
    extends Object
    implements Serializable, Cloneable

The configuration settings of a workflow type.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`WorkflowTypeConfiguration()`

### Method Summary

All Methods Instance Methods Concrete Methods
`WorkflowTypeConfiguration` `clone()`
`boolean` `equals(Object obj)`
`String` `getDefaultChildPolicy()` Optional. The default policy to use for the child workflow executions when a workflow execution of this type is terminated, by calling the TerminateWorkflowExecution action explicitly or due to an expired timeout.
`String` `getDefaultExecutionStartToCloseTimeout()` Optional. The default maximum duration, specified when registering the workflow type, for executions of this workflow type.
`String` `getDefaultLambdaRole()` The default IAM role to use when a workflow execution invokes a AWS Lambda function.
`TaskList` `getDefaultTaskList()` Optional. The default task list, specified when registering the workflow type, for decisions tasks scheduled for workflow executions of this type.
`String` `getDefaultTaskPriority()` Optional. The default task priority, specified when registering the workflow type, for all decision tasks of this workflow type.
`String` `getDefaultTaskStartToCloseTimeout()` Optional. The default maximum duration, specified when registering the workflow type, that a decision task for executions of this workflow type might take before returning completion or failure.
`int` `hashCode()`
`void` `setDefaultChildPolicy(ChildPolicy defaultChildPolicy)` Optional. The default policy to use for the child workflow executions when a workflow execution of this type is terminated, by calling the TerminateWorkflowExecution action explicitly or due to an expired timeout.
`void` `setDefaultChildPolicy(String defaultChildPolicy)` Optional. The default policy to use for the child workflow executions when a workflow execution of this type is terminated, by calling the TerminateWorkflowExecution action explicitly or due to an expired timeout.
`void` `setDefaultExecutionStartToCloseTimeout(String defaultExecutionStartToCloseTimeout)` Optional. The default maximum duration, specified when registering the workflow type, for executions of this workflow type.
`void` `setDefaultLambdaRole(String defaultLambdaRole)` The default IAM role to use when a workflow execution invokes a AWS Lambda function.
`void` `setDefaultTaskList(TaskList defaultTaskList)` Optional. The default task list, specified when registering the workflow type, for decisions tasks scheduled for workflow executions of this type.
`void` `setDefaultTaskPriority(String defaultTaskPriority)` Optional. The default task priority, specified when registering the workflow type, for all decision tasks of this workflow type.
`void` `setDefaultTaskStartToCloseTimeout(String defaultTaskStartToCloseTimeout)` Optional. The default maximum duration, specified when registering the workflow type, that a decision task for executions of this workflow type might take before returning completion or failure.
`String` `toString()` Returns a string representation of this object; useful for testing and debugging.
`WorkflowTypeConfiguration` `withDefaultChildPolicy(ChildPolicy defaultChildPolicy)` Optional. The default policy to use for the child workflow executions when a workflow execution of this type is terminated, by calling the TerminateWorkflowExecution action explicitly or due to an expired timeout.
`WorkflowTypeConfiguration` `withDefaultChildPolicy(String defaultChildPolicy)` Optional. The default policy to use for the child workflow executions when a workflow execution of this type is terminated, by calling the TerminateWorkflowExecution action explicitly or due to an expired timeout.
`WorkflowTypeConfiguration` `withDefaultExecutionStartToCloseTimeout(String defaultExecutionStartToCloseTimeout)` Optional. The default maximum duration, specified when registering the workflow type, for executions of this workflow type.
`WorkflowTypeConfiguration` `withDefaultLambdaRole(String defaultLambdaRole)` The default IAM role to use when a workflow execution invokes a AWS Lambda function.
`WorkflowTypeConfiguration` `withDefaultTaskList(TaskList defaultTaskList)` Optional. The default task list, specified when registering the workflow type, for decisions tasks scheduled for workflow executions of this type.
`WorkflowTypeConfiguration` `withDefaultTaskPriority(String defaultTaskPriority)` Optional. The default task priority, specified when registering the workflow type, for all decision tasks of this workflow type.
`WorkflowTypeConfiguration` `withDefaultTaskStartToCloseTimeout(String defaultTaskStartToCloseTimeout)` Optional. The default maximum duration, specified when registering the workflow type, that a decision task for executions of this workflow type might take before returning completion or failure.

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### WorkflowTypeConfiguration

    public WorkflowTypeConfiguration()

### Method Detail

#### setDefaultTaskStartToCloseTimeout

    public void setDefaultTaskStartToCloseTimeout(String defaultTaskStartToCloseTimeout)

Optional. The default maximum duration, specified when registering the workflow type, that a decision task for executions of this workflow type might take before returning completion or failure. If the task does not close in the specified time then the task is automatically timed out and rescheduled. If the decider eventually reports a completion or failure, it is ignored. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

The duration is specified in seconds; an integer greater than or equal to 0. The value "NONE" can be used to specify unlimited duration.

Parameters:
  `defaultTaskStartToCloseTimeout` - Optional. The default maximum duration, specified when registering the workflow type, that a decision task for executions of this workflow type might take before returning completion or failure. If the task does not close in the specified time then the task is automatically timed out and rescheduled. If the decider eventually reports a completion or failure, it is ignored. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

#### getDefaultTaskStartToCloseTimeout

    public String getDefaultTaskStartToCloseTimeout()

Optional. The default maximum duration, specified when registering the workflow type, that a decision task for executions of this workflow type might take before returning completion or failure. If the task does not close in the specified time then the task is automatically timed out and rescheduled. If the decider eventually reports a completion or failure, it is ignored. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

The duration is specified in seconds; an integer greater than or equal to 0. The value "NONE" can be used to specify unlimited duration.

Returns:
  Optional. The default maximum duration, specified when registering the workflow type, that a decision task for executions of this workflow type might take before returning completion or failure. If the task does not close in the specified time then the task is automatically timed out and rescheduled. If the decider eventually reports a completion or failure, it is ignored. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

#### withDefaultTaskStartToCloseTimeout

    public WorkflowTypeConfiguration withDefaultTaskStartToCloseTimeout(String defaultTaskStartToCloseTimeout)

Optional. The default maximum duration, specified when registering the workflow type, that a decision task for executions of this workflow type might take before returning completion or failure. If the task does not close in the specified time then the task is automatically timed out and rescheduled. If the decider eventually reports a completion or failure, it is ignored. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

The duration is specified in seconds; an integer greater than or equal to 0. The value "NONE" can be used to specify unlimited duration.

Parameters:
  `defaultTaskStartToCloseTimeout` - Optional. The default maximum duration, specified when registering the workflow type, that a decision task for executions of this workflow type might take before returning completion or failure. If the task does not close in the specified time then the task is automatically timed out and rescheduled. If the decider eventually reports a completion or failure, it is ignored. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setDefaultExecutionStartToCloseTimeout

    public void setDefaultExecutionStartToCloseTimeout(String defaultExecutionStartToCloseTimeout)

Optional. The default maximum duration, specified when registering the workflow type, for executions of this workflow type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

The duration is specified in seconds; an integer greater than or equal to 0. The value "NONE" can be used to specify unlimited duration.

Parameters:
  `defaultExecutionStartToCloseTimeout` - Optional. The default maximum duration, specified when registering the workflow type, for executions of this workflow type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

#### getDefaultExecutionStartToCloseTimeout

    public String getDefaultExecutionStartToCloseTimeout()

Optional. The default maximum duration, specified when registering the workflow type, for executions of this workflow type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

The duration is specified in seconds; an integer greater than or equal to 0. The value "NONE" can be used to specify unlimited duration.

Returns:
  Optional. The default maximum duration, specified when registering the workflow type, for executions of this workflow type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

#### withDefaultExecutionStartToCloseTimeout

    public WorkflowTypeConfiguration withDefaultExecutionStartToCloseTimeout(String defaultExecutionStartToCloseTimeout)

Optional. The default maximum duration, specified when registering the workflow type, for executions of this workflow type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

The duration is specified in seconds; an integer greater than or equal to 0. The value "NONE" can be used to specify unlimited duration.

Parameters:
  `defaultExecutionStartToCloseTimeout` - Optional. The default maximum duration, specified when registering the workflow type, for executions of this workflow type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setDefaultTaskList

    public void setDefaultTaskList(TaskList defaultTaskList)

Optional. The default task list, specified when registering the workflow type, for decisions tasks scheduled for workflow executions of this type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

Parameters:
  `defaultTaskList` - Optional. The default task list, specified when registering the workflow type, for decisions tasks scheduled for workflow executions of this type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution`

#### getDefaultTaskList

    public TaskList getDefaultTaskList()

Optional. The default task list, specified when registering the workflow type, for decisions tasks scheduled for workflow executions of this type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

Returns:
  Optional. The default task list, specified when registering the workflow type, for decisions tasks scheduled for workflow executions of this type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution`

#### withDefaultTaskList

    public WorkflowTypeConfiguration withDefaultTaskList(TaskList defaultTaskList)

Optional. The default task list, specified when registering the workflow type, for decisions tasks scheduled for workflow executions of this type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

Parameters:
  `defaultTaskList` - Optional. The default task list, specified when registering the workflow type, for decisions tasks scheduled for workflow executions of this type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution`
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setDefaultTaskPriority

    public void setDefaultTaskPriority(String defaultTaskPriority)

Optional. The default task priority, specified when registering the workflow type, for all decision tasks of this workflow type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

Valid values are integers that range from Java's `Integer.MIN_VALUE` (-2147483648) to `Integer.MAX_VALUE` (2147483647). Higher numbers indicate higher priority.

For more information about setting task priority, see Setting Task Priority in the Amazon Simple Workflow Developer Guide.

Parameters:
  `defaultTaskPriority` - Optional. The default task priority, specified when registering the workflow type, for all decision tasks of this workflow type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

  Valid values are integers that range from Java's `Integer.MIN_VALUE` (-2147483648) to `Integer.MAX_VALUE` (2147483647). Higher numbers indicate higher priority.

  For more information about setting task priority, see Setting Task Priority in the Amazon Simple Workflow Developer Guide

#### getDefaultTaskPriority

    public String getDefaultTaskPriority()

Optional. The default task priority, specified when registering the workflow type, for all decision tasks of this workflow type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

Valid values are integers that range from Java's `Integer.MIN_VALUE` (-2147483648) to `Integer.MAX_VALUE` (2147483647). Higher numbers indicate higher priority.

For more information about setting task priority, see Setting Task Priority in the Amazon Simple Workflow Developer Guide.

Returns:
  Optional. The default task priority, specified when registering the workflow type, for all decision tasks of this workflow type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

  Valid values are integers that range from Java's `Integer.MIN_VALUE` (-2147483648) to `Integer.MAX_VALUE` (2147483647). Higher numbers indicate higher priority.

  For more information about setting task priority, see Setting Task Priority in the Amazon Simple Workflow Developer Guide

#### withDefaultTaskPriority

    public WorkflowTypeConfiguration withDefaultTaskPriority(String defaultTaskPriority)

Optional. The default task priority, specified when registering the workflow type, for all decision tasks of this workflow type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

Valid values are integers that range from Java's `Integer.MIN_VALUE` (-2147483648) to `Integer.MAX_VALUE` (2147483647). Higher numbers indicate higher priority.

For more information about setting task priority, see Setting Task Priority in the Amazon Simple Workflow Developer Guide.

Parameters:
  `defaultTaskPriority` - Optional. The default task priority, specified when registering the workflow type, for all decision tasks of this workflow type. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

  Valid values are integers that range from Java's `Integer.MIN_VALUE` (-2147483648) to `Integer.MAX_VALUE` (2147483647). Higher numbers indicate higher priority.

  For more information about setting task priority, see Setting Task Priority in the Amazon Simple Workflow Developer Guide

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setDefaultChildPolicy

    public void setDefaultChildPolicy(String defaultChildPolicy)

Optional. The default policy to use for the child workflow executions when a workflow execution of this type is terminated, by calling the TerminateWorkflowExecution action explicitly or due to an expired timeout. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

The supported child policies are:

- TERMINATE: the child executions will be terminated.
- REQUEST_CANCEL: a request to cancel will be attempted for each child execution by recording a `WorkflowExecutionCancelRequested` event in its history. It is up to the decider to take appropriate actions when it receives an execution history with this event.
- ABANDON: no action will be taken. The child executions will continue to run.

Parameters:
  `defaultChildPolicy` - Optional. The default policy to use for the child workflow executions when a workflow execution of this type is terminated, by calling the TerminateWorkflowExecution action explicitly or due to an expired timeout. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

  The supported child policies are:

  - TERMINATE: the child executions will be terminated.
  - REQUEST_CANCEL: a request to cancel will be attempted for each child execution by recording a `WorkflowExecutionCancelRequested` event in its history. It is up to the decider to take appropriate actions when it receives an execution history with this event.
  - ABANDON: no action will be taken. The child executions will continue to run.
See Also:
  `ChildPolicy`

#### getDefaultChildPolicy

    public String getDefaultChildPolicy()

Optional. The default policy to use for the child workflow executions when a workflow execution of this type is terminated, by calling the TerminateWorkflowExecution action explicitly or due to an expired timeout. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

The supported child policies are:

- TERMINATE: the child executions will be terminated.
- REQUEST_CANCEL: a request to cancel will be attempted for each child execution by recording a `WorkflowExecutionCancelRequested` event in its history. It is up to the decider to take appropriate actions when it receives an execution history with this event.
- ABANDON: no action will be taken. The child executions will continue to run.

Returns:
  Optional. The default policy to use for the child workflow executions when a workflow execution of this type is terminated, by calling the TerminateWorkflowExecution action explicitly or due to an expired timeout. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

  The supported child policies are:

  - TERMINATE: the child executions will be terminated.
  - REQUEST_CANCEL: a request to cancel will be attempted for each child execution by recording a `WorkflowExecutionCancelRequested` event in its history. It is up to the decider to take appropriate actions when it receives an execution history with this event.
  - ABANDON: no action will be taken. The child executions will continue to run.
See Also:
  `ChildPolicy`

#### withDefaultChildPolicy

    public WorkflowTypeConfiguration withDefaultChildPolicy(String defaultChildPolicy)

Optional. The default policy to use for the child workflow executions when a workflow execution of this type is terminated, by calling the TerminateWorkflowExecution action explicitly or due to an expired timeout. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

The supported child policies are:

- TERMINATE: the child executions will be terminated.
- REQUEST_CANCEL: a request to cancel will be attempted for each child execution by recording a `WorkflowExecutionCancelRequested` event in its history. It is up to the decider to take appropriate actions when it receives an execution history with this event.
- ABANDON: no action will be taken. The child executions will continue to run.

Parameters:
  `defaultChildPolicy` - Optional. The default policy to use for the child workflow executions when a workflow execution of this type is terminated, by calling the TerminateWorkflowExecution action explicitly or due to an expired timeout. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

  The supported child policies are:

  - TERMINATE: the child executions will be terminated.
  - REQUEST_CANCEL: a request to cancel will be attempted for each child execution by recording a `WorkflowExecutionCancelRequested` event in its history. It is up to the decider to take appropriate actions when it receives an execution history with this event.
  - ABANDON: no action will be taken. The child executions will continue to run.
Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `ChildPolicy`

#### setDefaultChildPolicy

    public void setDefaultChildPolicy(ChildPolicy defaultChildPolicy)

Optional. The default policy to use for the child workflow executions when a workflow execution of this type is terminated, by calling the TerminateWorkflowExecution action explicitly or due to an expired timeout. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

The supported child policies are:

- TERMINATE: the child executions will be terminated.
- REQUEST_CANCEL: a request to cancel will be attempted for each child execution by recording a `WorkflowExecutionCancelRequested` event in its history. It is up to the decider to take appropriate actions when it receives an execution history with this event.
- ABANDON: no action will be taken. The child executions will continue to run.

Parameters:
  `defaultChildPolicy` - Optional. The default policy to use for the child workflow executions when a workflow execution of this type is terminated, by calling the TerminateWorkflowExecution action explicitly or due to an expired timeout. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

  The supported child policies are:

  - TERMINATE: the child executions will be terminated.
  - REQUEST_CANCEL: a request to cancel will be attempted for each child execution by recording a `WorkflowExecutionCancelRequested` event in its history. It is up to the decider to take appropriate actions when it receives an execution history with this event.
  - ABANDON: no action will be taken. The child executions will continue to run.
See Also:
  `ChildPolicy`

#### withDefaultChildPolicy

    public WorkflowTypeConfiguration withDefaultChildPolicy(ChildPolicy defaultChildPolicy)

Optional. The default policy to use for the child workflow executions when a workflow execution of this type is terminated, by calling the TerminateWorkflowExecution action explicitly or due to an expired timeout. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

The supported child policies are:

- TERMINATE: the child executions will be terminated.
- REQUEST_CANCEL: a request to cancel will be attempted for each child execution by recording a `WorkflowExecutionCancelRequested` event in its history. It is up to the decider to take appropriate actions when it receives an execution history with this event.
- ABANDON: no action will be taken. The child executions will continue to run.

Parameters:
  `defaultChildPolicy` - Optional. The default policy to use for the child workflow executions when a workflow execution of this type is terminated, by calling the TerminateWorkflowExecution action explicitly or due to an expired timeout. This default can be overridden when starting a workflow execution using the StartWorkflowExecution action or the `StartChildWorkflowExecution` decision.

  The supported child policies are:

  - TERMINATE: the child executions will be terminated.
  - REQUEST_CANCEL: a request to cancel will be attempted for each child execution by recording a `WorkflowExecutionCancelRequested` event in its history. It is up to the decider to take appropriate actions when it receives an execution history with this event.
  - ABANDON: no action will be taken. The child executions will continue to run.
Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `ChildPolicy`

#### setDefaultLambdaRole

    public void setDefaultLambdaRole(String defaultLambdaRole)

The default IAM role to use when a workflow execution invokes a AWS Lambda function.

Parameters:
  `defaultLambdaRole` - The default IAM role to use when a workflow execution invokes a AWS Lambda function.

#### getDefaultLambdaRole

    public String getDefaultLambdaRole()

The default IAM role to use when a workflow execution invokes a AWS Lambda function.

Returns:
  The default IAM role to use when a workflow execution invokes a AWS Lambda function.

#### withDefaultLambdaRole

    public WorkflowTypeConfiguration withDefaultLambdaRole(String defaultLambdaRole)

The default IAM role to use when a workflow execution invokes a AWS Lambda function.

Parameters:
  `defaultLambdaRole` - The default IAM role to use when a workflow execution invokes a AWS Lambda function.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### toString

    public String toString()

Returns a string representation of this object; useful for testing and debugging.

Overrides:
  `toString` in class `Object`
Returns:
  A string representation of this object.
See Also:
  `Object.toString()`

#### equals

    public boolean equals(Object obj)

Overrides:
  `equals` in class `Object`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### clone

    public WorkflowTypeConfiguration clone()

Overrides:
  `clone` in class `Object`